<?php

namespace EventPortal\Domain\ActionList;

use Illuminate\Support\Collection;

class ActionListTemplate
{
    public Collection $lists;

    public string $type;

    private bool $hasBeenResolved = false;

    public function __construct(string $type)
    {
        $this->type = $type;
        $this->lists = collect();
    }

    public function addList(ActionList $actionList): self
    {
        $this->lists->add($actionList);

        return $this;
    }

    public function get(): ActionListTemplate
    {
        if ($this->hasBeenResolved === false) {
            $this->resolve();
        }

        return $this;
    }

    private function resolve(): self
    {
        $this->lists
            ->transform(function (ActionList $actionList) {
                return $actionList->type($this->type)->get();
            })
            ->flatten(1);

        $this->hasBeenResolved = true;

        return $this;
    }
}
