<?php

namespace EventPortal\Tests\Feature\Admin\Speaker;

use EventPortal\Domain\Admin\Models\Admin;
use EventPortal\Domain\Permission\Models\Permission;
use EventPortal\Domain\Speaker\Models\Speaker;
use EventPortal\Tests\Support\Traits\SeedRolesAndPermissions;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Spatie\Snapshots\MatchesSnapshots;

class SpeakerIndexTest extends TestCase
{
    use RefreshDatabase, MatchesSnapshots, SeedRolesAndPermissions;

    /** @test **/
    public function can_view_index(): void
    {
        factory(Speaker::class)->state('snapshot')->create();

        $this->assertMatchesJsonSnapshot(
            $this->actingAsSuperAdmin()->get(route('admin.speaker.index'))->props()
        );
    }

    /** @test **/
    public function can_view_index_with_add_button_if_user_has_permission(): void
    {
        factory(Speaker::class)->state('snapshot')->create();

        $this->assertMatchesJsonSnapshot(
            $this->actingAsSuperAdmin()->get(route('admin.speaker.index'))->props()
        );
    }
}
